import 'package:flutter/material.dart';
import 'package:fluttered/architecture.dart';

import '../controllers/pvc_home_page_controller.dart';

class PVCHomePage extends StatelessWidget {
  final String title;

  PVCHomePage({@required this.title});

  @override
  Widget build(BuildContext context) {
    return StatelessImmutablePvc(
      controller: PVCHomePageController(title: title),
      builder: (context, controller, child) => Scaffold(
        appBar: AppBar(
          title: Text(controller.title),
        ),
        body: Center(
          child: ListView.builder(
            itemCount: controller.pages.length,
            itemBuilder: (BuildContext context, int index) {
              return ListTile(
                title: Text(controller.pages[index]),
                onTap: () {
                  controller.onListItemTap(context, index);
                },
              );
            },
          ),
        ),
      ),
    );
  }
}
