import 'package:flutter/material.dart';
import 'package:fluttered/architecture.dart';
import 'package:provider_view_controller_example/controllers/pvc_demo_immutable_controller.dart';

class StatelessImmutablePage extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return StatelessImmutablePvc(
      controller: PVCDemoImmutableController(),
      builder: (context, controller, child) => Scaffold(
        appBar: AppBar(
          title: Text('StatelessImmutablePVC'),
        ),
        body: Center(
          child: Column(
            mainAxisAlignment: MainAxisAlignment.center,
            children: <Widget>[
              Text(
                'You have pushed the button this many times:',
                style: TextStyle(fontSize: 22),
              ),
              Text(
                '${controller.counter}',
                style: Theme.of(context).textTheme.display1,
              ),
              SizedBox(height: 100),
              Text(
                'Tapping the button will not update the key even though "controller.incrementCounter()" method is changing state by calling "notifyListeners". This is because, "StatelessImutablePVC" creates a "Provider". A "Provider" does not notify it\'s consumers about changes, and thus the widget tree do not rebuild itself.',
                style: TextStyle(fontSize: 20),
              ),
            ],
          ),
        ),
        floatingActionButton: FloatingActionButton(
          onPressed: controller.incrementCounter,
          tooltip: 'Increment',
          child: Icon(Icons.add),
        ),
      ),
    );
  }
}
