import 'package:flutter/material.dart';
import 'package:fluttered/architecture.dart';

import '../controllers/pvc_demo_mutable_controller.dart';

class StatelessMutablePage extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return StatelessMutablePvc(
      controller: PVCDemoMutableController(),
      builder: (context, controller, child) => Scaffold(
        appBar: AppBar(
          title: Text('StatelessMutablePVC'),
        ),
        body: Center(
          child: Column(
            mainAxisAlignment: MainAxisAlignment.center,
            children: <Widget>[
              Text(
                'You have pushed the button this many times:',
                style: TextStyle(fontSize: 22),
              ),
              Text(
                '${controller.counter}',
                style: Theme.of(context).textTheme.display1,
              ),
              SizedBox(height: 100),
              Text(
                'Tapping the button is updating the UI with the new "counter" value. This is because, "StatelessMutablePVC" creates a "ChangeNotifierProvider". A "ChangeNotifierProvider" notifies it\'s consumers about changes, and thus the widget tree rebuild itself.',
                style: TextStyle(fontSize: 18),
              ),
            ],
          ),
        ),
        floatingActionButton: FloatingActionButton(
          onPressed: controller.incrementCounter,
          tooltip: 'Increment',
          child: Icon(Icons.add),
        ),
      ),
    );
  }
}
