import 'package:flutter/material.dart';

import '../pages/pvc_home_page.dart';
import '../pages/stateful_immutable_page.dart';
import '../pages/stateful_mutable_page.dart';
import '../pages/stateless_immutable_page.dart';
import '../pages/stateless_mutable_page.dart';

class RouteGenerator {
  static Route<dynamic> generateRoute(RouteSettings settings) {
    switch (settings.name) {
      case '/':
        return MaterialPageRoute(
          builder: (_) => PVCHomePage(title: 'PVC Demo'),
        );
      case 'StatelessImmutablePVC':
        return MaterialPageRoute(
          builder: (_) => StatelessImmutablePage(),
        );
      case 'StatefulImmutablePVC':
        return MaterialPageRoute(
          builder: (_) => StatefulImmutablePage(),
        );
      case 'StatelessMutablePVC':
        return MaterialPageRoute(
          builder: (_) => StatelessMutablePage(),
        );
      case 'StatefulMutablePVC':
        return MaterialPageRoute(
          builder: (_) => statefulMutablePage(),
        );
      default:
        return _errorRoute();
    }
  }

  static Route<dynamic> _errorRoute() {
    return MaterialPageRoute(builder: (_) {
      return Scaffold(
        appBar: AppBar(
          title: Text('Error page'),
        ),
        body: Center(
          child: Text('ERROR'),
        ),
      );
    });
  }
}
