// import 'package:flutter/material.dart';
// import 'package:provider/provider.dart';

// typedef BuilderFunction<T> = Widget Function(
//     BuildContext context, T controller, Widget child);

// /// Create a [StatefulWidget] using [Provider]. Once created, the widget tree never change.
// class StatefulPVC<T> extends StatefulWidget {
//   /// Whether this Widget is mutable.
//   final _mutable;

//   /// The controller for this view.
//   final T controller;

//   /// Build a widget tree based on the [controller] value. Once created, the widget
//   /// never rebuild itself.
//   ///
//   /// Must not be null.
//   final BuilderFunction<T> builder;

//   /// The child widget to pass to [builder].
//   ///
//   /// If a builder callback's return value contains a subtree that does not depend on the [controller],
//   /// it's more efficient to build that subtree once instead of rebuilding it on every change of the [controller].
//   ///
//   /// If the pre-built subtree is passed as the child parameter, [StatefulMutablePVC] will pass
//   /// it back to the builder function so that it can be incorporated into the build.
//   ///
//   /// Using this pre-built child is entirely optional, but can improve performance significantly in some cases.
//   final Widget child;

//   /// Called when this object is inserted into the tree.
//   ///
//   /// The framework will call this method exactly once for each [StatefulPVC] object
//   /// it creates.
//   final Function(T) onModelReady;

//   /// Create a [StatefulWidget] using [Provider], and bind the [controller] to it.
//   ///
//   /// `StatefulImmutablePVC` is immutable, as the name suggests. That means it will never
//   /// rebuild itself even if the controller changes its state.
//   ///
//   /// If you want the widget tree to rebuild when the [controller] changes its state,
//   /// use [StatelessMutablePVC] or [StatefulMutablePVC] instead.
//   ///
//   /// [onModelReady] is called when this object is inserted into the tree. The framework
//   /// will call this method exactly once for each [StatefulPVC] object it creates.
//   StatefulPVC({
//     @required this.controller,
//     @required this.builder,
//     @required this.onModelReady,
//   });

//   StatefulPVC._(this.controller, this.builder, this.onModelReady, this._mutable,
//       [this.child]);

//   factory StatefulPVC.mutable(
//     T controller,
//     BuilderFunction<T> builder,
//     Function(T) onModelReady,
//     Widget child,
//   ) {
//     assert(
//         T is ChangeNotifier, 'The "controller" must extend "ChangeNotifier"');
//     return StatefulPVC._(controller, builder, onModelReady, true, child);
//   }

//   factory StatefulPVC.imutable(
//     T controller,
//     BuilderFunction<T> builder,
//     Function(T) onModelReady,
//   ) {
//     return StatefulPVC._(controller, builder, onModelReady, false);
//   }

//   @override
//   _StatefulPVCState createState() => _StatefulPVCState<T>();
// }

// class _StatefulPVCState<T> extends State<StatefulPVC<T>> {
//   @override
//   void initState() {
//     if (widget.onModelReady != null) {
//       widget.onModelReady(widget.controller);
//     }
//     super.initState();
//   }

//   @override
//   Widget build(BuildContext context) {
//     if (widget._mutable) {
//       return ChangeNotifierProvider<T>(
//         builder: (context) => widget.controller,
//         child: Consumer<T>(
//           builder: widget.builder,
//           child: widget.child,
//         ),
//       );
//     } else {
//       return Provider<T>(
//         builder: (context) => widget.controller,
//         child: Consumer<T>(builder: widget.builder),
//         // dispose: (_, model) =>,
//       );
//     }
//   }
// }
